# include "stdio.h"

int swab8(from,to,bytes)
register char    *from;
register char    *to;
int               bytes;
{
  char            *FktName = "swab8";
  register char   *temp;
  char             z;

  if (bytes % 8 != 0) {
    fprintf(stderr,"%s: bytes ist nicht vielfaches von 8\n",FktName);
    return(-1);
  }
  bytes >>= 3; 
  if (to != NULL) { 
   to+=7;
   while(bytes-- > 0) { 
    *to-- = *from++; *to-- = *from++; *to-- = *from++; *to-- = *from++;
    *to-- = *from++; *to-- = *from++; *to-- = *from++; *to-- = *from++;
    to+=16; 
   }
  }
  else {
   temp = from + 7;
   while(bytes-- > 0) { 
     z = *from; *from++ = *temp; *temp-- = z;
     z = *from; *from++ = *temp; *temp-- = z;
     z = *from; *from++ = *temp; *temp-- = z;
     z = *from; *from++ = *temp; *temp-- = z;
     from += 4; temp += 12;
   } 
  }
  return(bytes);
}

int swab4(from,to,bytes)
register char    *from;
register char    *to;
int               bytes;
{
  char            *FktName = "swab4";
  register char   *temp;
  char             z;

  if (bytes % 4 != 0) {
    fprintf(stderr,"%s: bytes ist nicht vielfaches von 4\n",FktName);
    return(-1);
  }
  bytes >>= 2; 
  if (to != NULL) { 
   to+=3;
   while(bytes-- > 0) { 
    *to-- = *from++; *to-- = *from++; *to-- = *from++; *to-- = *from++;
    to += 8;  
   }
  }
  else {
   temp = from + 3;
   while(bytes-- > 0) { 
     z = *from; *from++ = *temp; *temp-- = z;
     z = *from; *from++ = *temp; *temp-- = z;
     from += 2; temp += 6;
   }
  }
  return(bytes);
}

int swab2(from,to,bytes)
register char    *from;
register char    *to;
int               bytes;
{
  char            *FktName = "swab2";
  register char   *temp;
  char             z;

  if (bytes % 2 != 0) {
    fprintf(stderr,"%s: bytes ist nicht vielfaches von 2\n",FktName);
    return(-1);
  }
  bytes >>= 1; 
  if (to != NULL) { 
   while(bytes-- > 0) { 
    z = *from++;*to++ = *from++;*to++ = z; 
   }
  }
  else {
   temp = from + 1; 
   while(bytes-- > 0) { 
     z = *from; *from++ = *temp; *temp-- = z; 
     temp += 3; from++;
   }
  }
  return(bytes);
}
